package gbook;

import java.sql.*;
import java.util.*;

public class DbHelper {

    // gets a db connection
    public static Connection getConnection() throws SQLException {
        Connection conn = null;
        try{

            // Microsoft Access PART
            // load db driver
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();
            // connect with a Data Source Name (DSN) of a database.
            conn = DriverManager.getConnection("jdbc:odbc:gbookdsn");

            // ORACLE PART
            /*
            // Load the JDBC driver
            String driverName = "oracle.jdbc.driver.OracleDriver";
            Class.forName(driverName).newInstance();    
            // Create a connection to the database
            String serverName = "oracle";
            String portNumber = "1521";
            String sid = "welby";
            String url = "jdbc:oracle:thin:@" + serverName + 
                ":" + portNumber + ":" + sid;
            String username = "particle";
            String password = "particle";
            conn = java.sql.DriverManager.getConnection(url, 
                               username, password);
            conn.setAutoCommit(true);
            */
        }catch(ClassNotFoundException e){
            e.printStackTrace();
        }catch(InstantiationException e){
            e.printStackTrace();
        }catch(IllegalAccessException e){
            e.printStackTrace();
        }
        return conn;
    }

    //add a guestbook record.
    public static void addGuestBook(GBook o){
        try{
            Connection connection = DbHelper.getConnection();
            Statement statement = connection.createStatement();

            // Microsoft Access INSERT
            String command = "INSERT INTO GBOOK" + 
                "(NAME,EMAIL,POSTDATE,MESSAGE) VALUES ('"+o.name+"',"+
                    "'"+o.email+"',NOW(),'"+o.message+"')";

            statement.execute(command);
            statement.close();
            connection.close();
        }catch(SQLException e){
            e.printStackTrace();
        }
    }

    // get all guest book entries
    public static Vector getGuestBook(){
        Vector v = new Vector();
        try{
            Connection connection = getConnection();

            Statement statement = connection.createStatement();

            // Microsoft Access INSERT
            String command = "SELECT * FROM GBOOK ORDER BY POSTDATE DESC";

            if(statement.execute(command)){    
                ResultSet rs = statement.getResultSet();
                while(rs.next()) {
                    GBook g = new GBook();
                    g.gbookid = rs.getInt("GBOOKID");
                    g.name = rs.getString("NAME");
                    g.email = rs.getString("EMAIL");
                    g.message = rs.getString("MESSAGE");
                    g.postdate = rs.getDate("POSTDATE");
                    v.addElement(g);
                }
            }
            statement.close();
            connection.close();
        }catch(SQLException e){
            e.printStackTrace();
        }
        return v;
    }
}


